{$ifdef DOTS_BASE64}
//2x2 pruhledny obrazek v png
const PNG_2x2='iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAIAAAD91JpzAAAABnRSTlMAAAAAAABupgeRAAAAC0lEQVQI12NgQAYAAA4AATHp3RUAAAAASUVORK5CYII=';
var MapPinboard_const:record
      fNorth, fSouth, fWest, fEast:extended;          //okraje mapy
      fMapNorth,fMapSouth,fMapWest,fMapEast:extended; //
      fLatScaling,fLonScaling:extended;
    end;

function MapPinboard_LatToGoogleY(Lat:extended):integer; //prevod Lat na Y mapy (od leveho horniho rohu mapy)
begin
  Result:=round(MapPinboard_const.fLatScaling*MapPinboard_const.fMapNorth
    -log(tan(pi()/180*Lat)+(1/cos(pi()*Lat/180))));
end;
//----------------------------------------------------------------------------
function MapPinboard_LonToGoogleX(Lon:extended):integer; //prevod Lon na X mapy (z leveho horniho rohu mapy)
begin
  Result:=round((Lon-MapPinboard_const.fWest)*MapPinboard_const.fLonScaling);
end;
//----------------------------------------------------------------------------
//vypocet parametru pro prevod Wgs souradnic do [X;Y] obrazku
function MapPinboard_CalcConstForMap(sGoogleUrl):boolean;
  //vstup: URL pro ziskani mapy, nacteme z toho souradnice stredu mapy
  //       zoom (priblizeni mapy), sirka a vyska mapy generovane googlem,
  //       meritko prevodu mapy na obrazek
  fOffset,fRadius        //konstanty pro vypocet
  ,fLat,fLon             //souradnice stredu mapy vracene googlem
  ,fLatPixels,fLonPixels //souradnice stredu mapy v px na zoomu 20
  ,fScale:extended;
  iZoom,:integer;
var
  //pravzit parametry z URL pro google
  $Lat=$Map['centerLat']; $Lon=$Map['centerLon']; $Zoom=$Map['zoom'];
  $Height=$Map['height']; $Width=$Map['width'];   $Scale=$Map['scale'];
  fOffset:=268435456.;   //velikost Google mapy na zoomu 20
  fRadius:=fOffset/pi();
  //pozice stredu mapy v px na zoomu 20
  fLatPixels:=fOffset-fRadius*log((1+sin(fLat*pi()/180))/(1-sin(fLat*pi()/180)))/2;
  //jizni a severni okraj mapy
  MapPinboard_const.fSouth:=(pi()/2-2*atan(exp((fLatPixels-fOffset+pow(2,(21-iZoom))
    *(iHeight/2.))/fRadius)))*180/pi();
  MapPinboard_const.fNorth:=(pi()/2-2*atan(exp((fLtPixels-fOffset-pow(2,(21-$Zoom))
    *(iHeight/2))/fRadius)))*180/pi();
  MapPinboard_const.fMapNorth:=log(tan(pi()/180*MapPinboard_const.fNorth)+(1/cos(pi()
    *MapPinboard_const.fNorth/180)));
  MapPinboard_const.fMapSouth:=log(tan(pi()/180*MapPinboard_const.fSouth)+(1/cos(pi()
    *MapPinboard_const.fSouth/180)));
  MapPinboard_const.fLatScaling:=iHeight/(MapPinboard_const.fMapNorth-MapPinboard_const.fMapSouth)
    *fScale;

//echo "XXXXX zadane hodnoty mapy: Lon=$Lon, Zoom=$Zoom, Width=$Width, Scale=$Scale<br>";
  //pozice stredu mapy v px na zoomu 20
  MapPinboard_const.fLonPixels:=fOffset+fRadius*fLon*pi()/180;
  //zapadni a vychodni okraj mapy
  MapPinboard_const.fWest:=((MapPinboard_const.fLonPixels-fOffset-pow(2,(21-iZoom))
    *(iWidth/2))/fRadius)*180/pi();
  MapPinboard_const.fEast:=((MapPinboard_const.fLonPixels-fOffset+pow(2,(21-iZoom))
    *(iWidth/2))/fRadius)*180/pi();
  MapPinboard_const.fLonScaling:=iWidth/(MapPinboard_const.fEast-MapPinboard_const.fWest)*fScale;
  Resut:=true;
end;

//vraci pruhlednou vrstvu s puntiky v png formatu zakodovanou do base64
function MapPinboard_ImgBase64(sArea,sDateFrom,sDateTo,iMapPinWidth,iMapPinHeight:integer):string; //oblast, rozsah datumu, ...
  //vypocteme konstanty pro zadanou mapu
  //vytvorime pruhledny obrazek z PNG_2x2
  //nacteme seznam kesi, ktere pro mapu potrebujeme
  //zakreslime vsechny nalezene kese do mapy
  //prevedeme obrazek do png
  //prevedeme png na base43
  Result:=...
end;
{$endif}


function MapPinboard_GoogleUrl(aPar:TStringList; iMapPinWidth:integer; var iMapPinHeight:integer; var sChgeo,sChm:string):string;
  //zjisti URL pro ziskani mapy a jeji vysku
var ini:TMemIniFile;
    s,s1,sArea,sStyle,sCenterLat,sCenterLon:string;
    iMapWidth,iMapHeight,iZoom,iScale:integer;
    fx,fy,fMer:extended;
begin
  Result:='';
  s:=aPar.Values['MapStyle']; sStyle:=Fetch(s,'-');
  sArea:=aPar.Values['Area']; //ponechame vcetne toho, co je za '-' (stat i jine oblasti mohou obsahovat i pomlcku?)
  s:=sArea;          //pro Custom oblast nechame jen Custom, ale ostatni oblasti
  s1:=Fetch(s,'-');  //musime ponechat cele i s '-'
  if(s1='Custom') then sArea:=s1;

  // nastaveni stylu mapy
  if sStyle='CustomStyle' then begin
    sChm:='&'+ReplaceString(aPar.Values['CustomStyle'],'%CRLF%','&');
  end
  else begin
    ini:=TMemIniFile.Create(GetModulesDir()+'MapPinboard.Style.ini');
    try
      sChm:=ini.ReadString(sStyle,'Style',sStyle);
    finally
      ini.Free();
    end;
  end;
  //sChm:=EncodeUrlElement(sChm); //zakodujeme nebezpecne znaky

  // nastaveni oblasti mapy 
  if sArea='Custom' then begin
    s:=aPar.Values['CustomCenterPoint']; //prevedeme na float
    if(ParseWgsStr(s, fx,fy)) then begin
      sCenterLat:=FormatFloatDot('#.0000',fx);
      sCenterLon:=FormatFloatDot('#.0000',fy);
    end 
    else begin
      sCenterLat:='0';
      sCenterLon:='0';
    end;
    try
      iMapWidth:=StrToInt(aPar.Values['CustomWidth']);
      iMapHeight:=StrToInt(aPar.Values['CustomHeight']);
      iZoom:=StrToInt(aPar.Values['CustomZoom']);
    except
      iMapWidth:=640;
      iMapHeight:=640;
      iZoom:=1;
    end;
  end 
  else begin
    ini:=TMemIniFile.Create(GetModulesDir()+'MapPinboard.Area.ini');
    try
      sCenterLat:=ini.ReadString(sArea,'centerLat','');
      sCenterLon:=ini.ReadString(sArea,'centerLon','');
      iMapWidth:=ini.ReadInteger(sArea,'width',-1);
      iMapHeight:=ini.ReadInteger(sArea,'height',-1);
      iZoom:=ini.ReadInteger(sArea,'zoom',-1);
      if(sCenterLat='') or (sCenterLon='') or (iMapWidth<=0) or (iMapHeight<=0) or (iZoom<0) then
        AddError(_('ERR: Area or it''s parameters are NOT defined in INI file. Area:')+' '+sArea);
      if(sCenterLat='') then sCenterLat:='0';
      if(sCenterLon='') then sCenterLon:='0';
      if(iMapWidth<=0) then iMapWidth:=640;
      if(iMapHeight<=0) then iMapHeight:=640;
      if(iZoom<0) then iZoom:=1;
    finally
      ini.Free();
    end;
  end;
  //pomer stran mapy a z nej zjistime vysku vysledneho obrazku
  iScale:=1;
  if(iMapWidth<iMapPinWidth) then iScale:=2;
  fMer:=1.0*iMapWidth/iMapHeight;
  iMapPinHeight:=round((0.+iMapPinWidth)/fMer);         //vyska vysledneho obrazku
  sChgeo:=sCenterLat+','+sCenterLon
    +','+IntToStr(iMapWidth)+','+IntToStr(iMapHeight)+','+IntToStr(iZoom);
  Result:='center='+sCenterLat+','+sCenterLon
    +'&zoom='+IntToStr(iZoom)
    +'&size='+IntToStr(iMapWidth)+'x'+IntToStr(iMapHeight)
    +'&scale='+IntToStr(iScale)
    +sChm
    ;
  Log('Url pro podklad k puntikate mape: '+Result);
end;

function MapPinboard_Run(aPar:TStringList):string;
var s,sL,sArea,sChdot,sMap,sUrl,sChgeo,sChm,sDateFrom,sID,sYears,sText,sBorder:string;
    i,iYearMin,iYearMax,iYearFrom,iMapPinWidth,iMapPinHeight:integer;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  //nacist parametry
  //zkontrolujeme, zda pro zdroj gc.cz je k dispozici ID uzivatele
  if(sGcCzId='') then begin
    AddError(_('ERR: GcCzId not set')); 
    exit;
  end;
  s:=aPar.Values['MapType'];      sMap:=Fetch(s,'-');
  iMapPinWidth:=iWidth-2;         //misto na ramecek
  
  //pripravime parametry pro puntiky
  sChdot:=sGcCzId+','+aPar.Values['DotsSize']+','
    +GlobalVarGetColor('ColorMapDots','C00000') //pokud neni barva nastavena, pouzijeme tmave cervenou
    ;
  iYearMin:=Geoget_DB.GetTableValue('SELECT MIN(dtfound/10000) FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql);
  iYearMax:=Geoget_DB.GetTableValue('SELECT MAX(dtfound/10000) FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql);


  //v zavislosti na tom, zda ma byt generovany puntiky na pruhlednem nebo mapovem
  //generujeme odkazy

  // pripravit URL a spocitat vysku obrazku
  sUrl:=MapPinboard_GoogleUrl(aPar,iMapPinWidth,iMapPinHeight,sChgeo,sChm);
  if(sUrl='') then exit; //doslo k chybe, ukoncime se
  // oramovani
  if aPar.Values['Border']='Yes' then 
    sBorder:='border:1px solid #7B7B7B'
  else
    sBorder:='border:1px solid #'+GlobalVarGetColor('ColorMainBkg','FFFFFF');

  s:=CONST_MAPGEN_URL+'mapgen.php?'
  if(sMap='DotsMap') then
    Result:=Result+'<div style="'+sBorder+'; "><img src="'+s
    +'cht=t,'+sMap
    +'&chtm='+sArea
    +'&chs=wx'+IntToStr(iMapPinWidth)
    +'&chdot='+sChdot+',-1,-1,'+aPar.Values['DotsHeatColor']
    +'&chm='+EncodeUrlElement(sChm)+'" /></div>'+CRLF
  else begin
    // spolecny kus HTML pro prekryvne vrstvy s puntiky
    sL:='<img width="'+IntToStr(iMapPinWidth)+'" height="'+IntToStr(iMapPinHeight)+'" src="'+s
      +'cht=t,'+sMap
      +'&chtm=Custom'
      +'&chgeo='+sChgeo
      +'&chs=wx'+IntToStr(iMapPinWidth)
      +'&chm=';
    // parametry pro vrstvy
    s:=aPar.Values['YearlyDots'];   sYears:=Fetch(s,'-');
    iYearFrom:=iYearMin;
    if sYears='All' then iYearFrom:=iYearMax;

    // vygenerovat URL pro google (format je png nebo podle dokumentace jen png8/png32?)
    sUrl:='https://maps.googleapis.com/maps/api/staticmap?'+sUrl+'&format=png';
{$ifdef DOTS_BASE64}
    //pokud je pozadavek na na IMG v base64 primo v HTML, vygenerujeme jej
    //http://dean.edwards.name/weblog/2005/06/base64-ie/
    //https://en.wikipedia.org/wiki/Data_URI_scheme
    if(sMap='DotsInline') then begin
      MapPinboard_CalcConstForMap(sUrl,iMapPinWidth,iMapPinHeight); //vypocet konstant
      sImg:=MapPinboard_ImgBase64(sArea,sDateFrom,sDateTo,iMapPinWidth,iMapPinHeight);
    end;
{$endif}
      
    Result:=Result+'<div style="font-size:0; line-height:0; '+sBorder+'">'+CRLF
      +'<img width="'+IntToStr(iMapPinWidth)+'" height="'+IntToStr(iMapPinHeight)+'" '
      +'src="'+sUrl+'">'+CRLF;
    // prekryvne vrstvy s puntiky
    for i:=iYearFrom to iYearMax do begin
      s:='none'; 
      if (sYears='Years') and (i=iYearMin) then s:='';
      if (sYears<>'Years') and (i=iYearMax) then s:='';
      sDateFrom:=IntToStr(iYearMin)+'-01-01';
      if sYears='Years' then sDateFrom:=IntToStr(i)+'-01-01';
      Result:=Result+'<div id="L'+IntToStr(iItem)+IntToStr(i)+'" style="display:'+s+'; '
        +'margin-top:-'+IntToStr(iMapPinHeight)+'px; line-height:0;">'+CRLF
        +sL
        +'&chdot='+sChdot+','+sDateFrom+','+IntToStr(i)+'-12-31,'+aPar.Values['DotsHeatColor']
        +'" />'+CRLF
        +'</div>'+CRLF;
    end;
    // prepinaci logika vrstev
    if sYears<>'All' then begin 
      sID:='B-'+IntToStr(iItem);
      if sYears='Years' then begin
        sText:=_('Finds in year');
        s:=IntToStr(iYearFrom);
      end
      else begin
        sText:=_('Finds until');
        s:=IntToStr(iYearMax);
      end;
      Result:=Result+'<div style="margin-top:-'+IntToStr(iMapPinHeight)+'px; height:'+IntToStr(iMapPinHeight-20)+'px; padding: 10px 20px; text-align:right;">'+CRLF
        +'<span style="padding: 5px 15px; display:inline-block; background-color:white; opacity:0.7; border-radius:5px; font-size:small;">'
        +'<b>'+sText+': </b><span style="font-size:large; font-weight:bold; line-height:normal;">';
      if aPar.Values['UpDownButtons']='Yes' then begin 
        Result:=Result+'<span style="opacity:0.5; cursor: pointer;" '
        +'onclick="var x=document.getElementById('''+sID+''');xx=Number(/\d\d\d\d/.exec(x.innerHTML));xx--;if(xx<'+IntToStr(iYearMin)+'){xx='+IntToStr(iYearMax)+'};x.innerHTML=xx;'
        +'for(i='+IntToStr(iYearMin)+';i<'+IntToStr(iYearMax+1)+';i++){document.getElementById(''L'+IntToStr(iItem)+'''+i).style.display=''none''};'
        +'document.getElementById(''L'+IntToStr(iItem)+'''+xx).style.display='''';return false;">&#9664;&nbsp;</span>'
        +'<span id="'+sID+'" >'+s+'</span>'
        +'<span style="opacity:0.5; cursor: pointer;" '
        +'onclick="var x=document.getElementById('''+sID+''');xx=Number(/\d\d\d\d/.exec(x.innerHTML));xx++;if(xx>'+IntToStr(iYearMax)+'){xx='+IntToStr(iYearMin)+'};x.innerHTML=xx;'
        +'for(i='+IntToStr(iYearMin)+';i<'+IntToStr(iYearMax+1)+';i++){document.getElementById(''L'+IntToStr(iItem)+'''+i).style.display=''none''};'
        +'document.getElementById(''L'+IntToStr(iItem)+'''+xx).style.display='''';return false;">&nbsp;&#9654;</span>'
      end else begin
      Result:=Result+'<span style="cursor: pointer;" '
        +'onclick="var x=document.getElementById('''+sID+''');xx=Number(/\d\d\d\d/.exec(x.innerHTML));xx++;if(xx>'+IntToStr(iYearMax)+'){xx='+IntToStr(iYearMin)+'};x.innerHTML=xx;'
        +'for(i='+IntToStr(iYearMin)+';i<'+IntToStr(iYearMax+1)+';i++){document.getElementById(''L'+IntToStr(iItem)+'''+i).style.display=''none''};'
        +'document.getElementById(''L'+IntToStr(iItem)+'''+xx).style.display='''';return false;">'
        +'<span id="'+sID+'">'+s+'</span><span style="opacity:0.5;">&nbsp;&#9654;</span></span>';
      end;
      Result:=Result+'</span></span>'+CRLF+'</div>';
    end;
    
    // konec
    Result:=Result+'</div>'+CRLF;
  end;
end;